#include "../../internal-include/BootLoader/boot_loader.hpp"
#include "../../internal-include/System/callbacks_internal.hpp"

namespace JabyEngine {    
    namespace boot {
        namespace Callbacks {
            namespace InternalCallback = JabyEngine::Callback::internal;

            void setup() {
                SysCall::EnterCriticalSection();
                    InternalCallback::VSync::thread_handle = SysCall::OpenThread(
                        InternalCallback::VSync::routine,
                        &InternalCallback::VSync::stack[InternalCallback::VSync::StackSize - 1],
                        SysCall::get_gp()
                    );
                    Thread::set_user_mode_for(InternalCallback::VSync::thread_handle);
                SysCall::ExitCriticalSection();
            }
        }
    }
}